/*------------------------------------------------------------------------------
* corrfunc.c: mex function corrfunc
*
* 2010/11/03 0.1 new
*-----------------------------------------------------------------------------*/
#include "mex.h"
#include "sdr.h"

/* mex interface -------------------------------------------------------------*/
extern void mexFunction(int nargout, mxArray *argout[], int nargin,
                        const mxArray *argin[])
{
    double ti,freq,crate,*P;
    char *data;
    int dtype,ctype,sat,n;
    
    if (nargin<7||
        mxGetM(argin[0])<1||mxGetM(argin[1])<1||mxGetM(argin[2])<1||
        mxGetM(argin[3])<1||mxGetM(argin[4])<1||mxGetM(argin[5])<1||
        mxGetM(argin[6])<1||!mxIsInt8(argin[0])) {
        mexErrMsgTxt("argin error");
    }
    data =(char *)mxGetPr(argin[0]); /* I: sampling signal */
    dtype=(int)  *mxGetPr(argin[1]); /* I: sampling type (0:real,1:I/Q) */
    ti   =       *mxGetPr(argin[2]); /* I: sampling interval (s) */
    freq =       *mxGetPr(argin[3]); /* I: frequency (Hz) */
    sat  =(int)  *mxGetPr(argin[4]); /* I: satellite number */
    ctype=(int)  *mxGetPr(argin[5]); /* I: code type */
    crate=       *mxGetPr(argin[6]); /* I: code chip rate (chip/s) */
    
    n=(int)mxGetN(argin[0]);
    if (dtype) n/=2;
    
    argout[0]=mxCreateDoubleMatrix(1,n,mxREAL);
    
    P    =       mxGetPr(argout[0]); /* O: correlator function */
    
    corrfunc(data,dtype,ti,n,freq,sat,ctype,crate,P);
}
